{#
Template containing a jinja macro for styling WTForms.
This macro was obtained from https://gist.github.com/pwalsh/d3eb06ad098abcc9cb1d
and got slightly modified
Author: Jero Schäfer
Last modified: 01.07.2020
#}

{% macro render_field(field) -%}

    {# Diplay label #}
    {% set with_label = kwargs.pop('with_label', False) %}
    {% set inline = kwargs.pop('inline', False) %}

    {# Placeholder #}
    {% set placeholder = kwargs.pop('placeholder', field.label.text) %}

    {# Class #}
    {% set class_ = kwargs.pop('class_', '') %}

    {# Add required to class if this is a required field #}
    {% if field.flags.required %}
        {% set class_ = class_ + ' required' %}
    {% endif %}

    {# Form group, add inline option if desired (default False) #}
    <div class="form-group row{% if inline %} form-inline{% endif %}">

        {# Show the label if exists #}
        {% if with_label %}
{#            <label for="{{ field.id }}" class="control-label{% if field.flags.required %} required{% endif %}#}
{#                                               {% if inline %} col-sm-2 col-form-label{% endif %}">#}
            <label for="{{ field.id }}" class="col-sm-2 col-form-label{% if field.flags.required %} required{% endif %}">
                {{ field.label.text }}
            </label>
        {% endif %}

        {# Boolean fields #}
        {% if field.type == 'BooleanField' %}
            <div class="checkbox">
                <label>
                    {{ field(class_=class_, **kwargs) }}
                    {{ field.label.text|safe }}
                </label>
            </div>
        {# Other fields (TextField, StringField, FileField, ...) #}
        {% else %}
            {% if field.type in ('TextField', 'StringField', 'IntegerField') %}
                {% set class_ = class_ + ' input-xlarge form-control' %}
            {% elif field.type == 'FileField' %}
                {% set class_ = class_ + ' input-file form-control' %}
            {% elif field.type == 'SubmitField' %}
                {% set class_ = class_ + ' btn btn-success' %}
            {% endif %}

            {% if field.type == 'SelectField' %}
                {% set class_ = class_ + ' form-control' %}
                {{ field(class_=class_, **kwargs) }}
            {% else %}
                <div class="col-sm-10">
                    {{ field(class_=class_, placeholder=placeholder, **kwargs) }}
                </div>
            {% endif %}
        {% endif %}



        {# Description of the field #}
        {% if field.description %}
            <p class="help-block">{{ field.description|safe }}</p>
        {% endif %}

    </div>
{%- endmacro %}